//This is a program that demonstrates the use of software LCD control with
//Microchips Libraries.It simply displays "Hello World!" 
//The External LCD Section is documented on P#79 of C18 Libraries
//Use 18f452lcd sim.DSN
//Replace this xlcd.h in the MCC18>h folder.
//Add all files in the folder in your projec.Also present in MCC18 isntallation folder.
//Pin changes have been made in the provided xlcd.h file.

#include<p18f452.h>// Include files and definitions for the Processor
#include<xlcd.h>// Include function definitions for the External LCD Library library
#include<delays.h>// Include function definitions for built in Delay routines
#pragma config LVP=OFF
#pragma config OSC=HS
#pragma config WDT=OFF// Use internal Oscillator, Watchdog off, LVP off


void DelaySTRING(void);
void main(void)
{
	int z;
    static const char data[]="HEllO WORLD. THIS IS A TEST ";
	unsigned char data1[]="GOODMORNING";
	unsigned char start[]="LCD has programed with PIC18F452";
	unsigned char start1[]="LCD help us to display data from PICs";
	unsigned char start2[]="PIC can send data to external RAM, bright LED and more";
 
	unsigned char newlineadd=0x40; // Line 2 addresses are 40h to 4Fh

    //OSCCON=0x60;//Internal 4MHZ Oscillator
//	ADCON1=0X7F;//Make all ports Digital	

	OpenXLCD( EIGHT_BIT & LINES_5X7 );// Use 8 bit Data, 5x7 pixel Matrix per character
	while( BusyXLCD());// Wait till LCD finishes executing command
	WriteCmdXLCD( CURSOR_ON);// Turn cursor ON
    WriteCmdXLCD(0x80); // Force curson to the begining of 1st line
	while( BusyXLCD() );// Wait till LCD finishes executing command
   WriteCmdXLCD( SHIFT_DISP_LEFT );//Shift Cursor Display Left
	while( BusyXLCD());// Wait till LCD finishes executing command
     
	putsXLCD(data);// Write the String data to the LCD
	WriteCmdXLCD(0b0000110); // 0b0011111
	while( BusyXLCD() );
   WriteCmdXLCD( 0xC0);// Force curson to the begining of 2nd line
  //SetDDRamAddr( newlineadd );
	while( BusyXLCD() );

    putsXLCD(data1);// Write the String data to the LCD
    WriteCmdXLCD(SCROLL);
  
  	DelaySTRING();

/*********************Apofasi gia address RAM*****************************/
	while( BusyXLCD());// Wait till LCD finishes executing command
	WriteCmdXLCD(0b00000001);// Clear Display
 	while( BusyXLCD() );// Wait till LCD finishes executing command
    WriteCmdXLCD( SHIFT_DISP_LEFT );//Shift Cursor Display Left
	while( BusyXLCD());// Wait till LCD finishes executing command
 	putsXLCD(start);// Write the String data to the LCD
	WriteCmdXLCD(SCROLL);
	while( BusyXLCD() );
    SetDDRamAddr( newlineadd );
	while( BusyXLCD() );
    putsXLCD(start1);// Write the String data to the LCD
    DelaySTRING();
    while( BusyXLCD());// Wait till LCD finishes executing command
	WriteCmdXLCD(0b00000001);// Clear Display
 	while( BusyXLCD() );// Wait till LCD finishes executing command
    WriteCmdXLCD( SHIFT_DISP_LEFT );//Shift Cursor Display Left
	while( BusyXLCD());// Wait till LCD finishes executing command
 	putsXLCD(start2);// Write the String data to the LCD
	WriteCmdXLCD(SCROLL);
	while( BusyXLCD() );
    SetDDRamAddr( newlineadd );
	while( BusyXLCD() );
     	
	TRISB=0;   //PortB as output
	TRISD=0;   // PortD as output
	PORTB=0;

/** bringing LED**/
 for(z=0;z<=255;z++)
      {
 DelaySTRING();  
      PORTB = z;
      PORTD = z*z;
      }

    while(1);// Wait here
}


// As indicated in the C18 libraries manual
// These delays are required for LCD operation

/****************************************************************/
//  DelayFor18TCY  =18 cycles.
/****************************************************************/

void DelayFor18TCY(void)
{
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
}


/****************************************************************/
//  DelayPORXLCD  =15 ms.
/****************************************************************/

void DelayPORXLCD(void)
{
Delay1KTCYx(15);
}

/****************************************************************/
//  DelayXLCD  =5 ms.
/****************************************************************/

void DelayXLCD(void)
{
Delay1KTCYx(5);
}

/****************************************************************/
//  DelayString  =250 ms.
/****************************************************************/

void DelaySTRING(void)
{
Delay1KTCYx(250);
}